Subject: [quicwg/base-drafts] Clarify 'packet protection' -> 'packet number protection' (#1406)

From: Alessandro Ghedini <[email-masked]>
Date: Fri, 01 Jun 2018 09:02:14 -0700

You can view, comment on, or merge this pull request online at:

  https://github.com/quicwg/base-drafts/pull/1406

-- Commit Summary --

  * Clarify 'packet protection' -> 'packet number protection'

-- File Changes --

    M draft-ietf-quic-tls.md (12)

-- Patch Links --

https://github.com/quicwg/base-drafts/pull/1406.patch
https://github.com/quicwg/base-drafts/pull/1406.diff

-- 
You are receiving this because you are subscribed to this thread.
Reply to this email directly or view it on GitHub:
https://github.com/quicwg/base-drafts/pull/1406

---

From: MikkelFJ <[email-masked]>
Date: Fri, 01 Jun 2018 09:09:17 -0700

I'm not convinced this is a proper change. The packer number protection key in terms of label used, and length, is based on a the packet protection algorithm, not a separate isolated packet number protection algorithm.

-- 
You are receiving this because you are subscribed to this thread.
Reply to this email directly or view it on GitHub:
https://github.com/quicwg/base-drafts/pull/1406#issuecomment-393928608

---

From: Alessandro Ghedini <[email-masked]>
Date: Fri, 01 Jun 2018 10:13:07 -0700

@mikkelfj I'm not sure I follow, do you mean "The size of the packet number protection key is determined by the packet number protection algorithm" should instead be "The size of the packet number protection key is determined by the packet protection algorithm"? That is, remove the second "number" I added in that sentence?

-- 
You are receiving this because you are subscribed to this thread.
Reply to this email directly or view it on GitHub:
https://github.com/quicwg/base-drafts/pull/1406#issuecomment-393947232

---

From: Mike Bishop <[email-masked]>
Date: Fri, 01 Jun 2018 18:05:19 +0000 (UTC)

MikeBishop commented on this pull request.

To go by line 940, "packet protection" is the payload encryption, and "packet number protection" is applied afterward.  I initially thought you'd confused them, but after re-reading a couple of times, I think all the statements you make in the updated text are correct.

I'm not convinced they're equivalent to what the old text was trying to say, however.

> @@ -826,8 +826,8 @@ in Section 5.3 of {{!TLS13}}, the IV length is the larger of 8 or N_MIN (see
 Section 4 of {{!AEAD=RFC5116}}; all ciphersuites defined in {{!TLS13}} have
 N_MIN set to 12).
 
-The size of the packet protection key is determined by the packet protection
-algorithm, see {{pn-encrypt}}.
+The size of the packet number protection key is determined by the packet number
+protection algorithm, see {{pn-encrypt}}.

The existing statement is true as well.  Perhaps say that the size of both keys depends on the negotiated AEAD?

-- 
You are receiving this because you are subscribed to this thread.
Reply to this email directly or view it on GitHub:
https://github.com/quicwg/base-drafts/pull/1406#pullrequestreview-125264525

---

From: Alessandro Ghedini <[email-masked]>
Date: Fri, 01 Jun 2018 18:59:49 +0000 (UTC)

ghedo commented on this pull request.

So, the way I read it, is that key *and IV* length (i.e. key_length and iv_length) is actually defined in the paragraph before, but nowhere it says how long is the packet number encryption key (i.e. pn_key_length) which is what confused me (also considering the "see {{pn-encrypt}}" which didn't make a whole lot of sense to me since packet number encryption wasn't mentioned at all in that sentence).

-- 
You are receiving this because you are subscribed to this thread.
Reply to this email directly or view it on GitHub:
https://github.com/quicwg/base-drafts/pull/1406#discussion_r192487235

---

From: Alessandro Ghedini <[email-masked]>
Date: Fri, 01 Jun 2018 12:01:37 -0700

Though I'm fine adding both, it just seems superfluous.

-- 
You are receiving this because you are subscribed to this thread.
Reply to this email directly or view it on GitHub:
https://github.com/quicwg/base-drafts/pull/1406#discussion_r192487720

---

From: MikkelFJ <[email-masked]>
Date: Fri, 01 Jun 2018 19:09:18 +0000 (UTC)

> @mikkelfj I'm not sure I follow, do you mean "The size of the packet number protection key is determined by the packet number protection algorithm" should instead be "The size of the packet number…

Yes

-- 
You are receiving this because you are subscribed to this thread.
Reply to this email directly or view it on GitHub:
https://github.com/quicwg/base-drafts/pull/1406#issuecomment-393981152

---

From: Alessandro Ghedini <[email-masked]>
Date: Fri, 01 Jun 2018 12:27:22 -0700

> Yes

Ok, so I thought about that too, but "packet number protection algorithm" is explicitly defined in the pn-encrypt section which says "The packet number protection algorithm depends on the negotiated AEAD", so it kind of seemed like a a repetition that the pn protection key length is the same as protection algorithm key length *and* that pn protection algo is also the same as protection algo (that is, negotiated AEAD).

Again, don't have a strong opinion and would be happy to change, but seems superfluous.

-- 
You are receiving this because you are subscribed to this thread.
Reply to this email directly or view it on GitHub:
https://github.com/quicwg/base-drafts/pull/1406#issuecomment-393985538

---

From: Martin Thomson <[email-masked]>
Date: Fri, 01 Jun 2018 16:05:12 -0700

Merged #1406.

-- 
You are receiving this because you are subscribed to this thread.
Reply to this email directly or view it on GitHub:
https://github.com/quicwg/base-drafts/pull/1406#event-1659333573

---

From: Martin Thomson <[email-masked]>
Date: Fri, 01 Jun 2018 16:05:55 -0700

Thanks for clarifying this.  We can consider separately improving the description of the packet protection stuff, but given that it's likely to disappear very soon, let's not make extra work for ourselves.

-- 
You are receiving this because you are subscribed to this thread.
Reply to this email directly or view it on GitHub:
https://github.com/quicwg/base-drafts/pull/1406#issuecomment-394031643